<?php
/*
Plugin Name: SpamBlog
Plugin URI: http://www.kminek.pl/jak-postawic-spambloga-na-wordpressie/
Description: Przykładowa implementacja SpamBloga na WordPressie.
Author: Grzegorz Wójcik
Version: 1.0
Author URI: http://www.kminek.pl/
*/

include_once(ABSPATH . WPINC . '/rss.php');
include_once('wp_xmlrpc_api.class.php');

	function spamblog_pobierz_rss( $url, $num_items = 1 ) {
		
		if ( $rss = fetch_rss( $url ) ) {
			
			if ( $num_items !== -1 ) {
				$rss->items = array_slice( $rss->items, 0, $num_items );
			}
			
			return $rss->items[0];
			
		} else {
		
			return false;
		
		}

	}

	function spamblog_dodaj_posty() {

		$wp = new WP_xmlrpc_api('http://www.blogB.pl/xmlrpc.php', 'admin', 'qwerty');
		$wp->uzywajcurl = true;
		
		$onet = spamblog_pobierz_rss('http://wiadomosci.onet.pl/2,kategoria.rss');
		$poradnik_internauty = spamblog_pobierz_rss('http://poradnikwebmastera.blox.pl/rss2');
		
		if ($onet && spamblog_dodaj_url($onet['link'])) $wp->nowyPost($onet['title'], $onet['description'], array(3));
		if ($poradnik_internauty && spamblog_dodaj_url($poradnik_internauty['link'])) $wp->nowyPost($poradnik_internauty['title'], $poradnik_internauty['description'], array(4));
		
	}

/* 
permanentnie wlaczamy obsluge XML_RPC w WP
*/

update_option('enable_xmlrpc', 1);	

/* 
dodajemy funkcje spamblog_dodaj_posty() do WordPressowego harmonogramu zadan, zobacz:
http://codex.wordpress.org/Function_Reference/wp_schedule_event
*/
	
	add_action('spamblog_dodaj_posty_hook', 'spamblog_dodaj_posty');
	
	function spamblog_activate() {
		wp_schedule_event( time(), 'hourly', 'spamblog_dodaj_posty_hook' );
	}

	function spamblog_deactivate() {
		wp_clear_scheduled_hook('spamblog_dodaj_posty_hook');
	}

register_activation_hook(__FILE__, 'spamblog_activate' );
register_deactivation_hook(__FILE__, 'spamblog_deactivate' );

/* 
aby nie duplikowac juz dodanych postow, zapisujemy URL kazdego z nich (z feeda) w bazie danych i sprawdzamy
czy juz taka pozycja nie istnieje (wtedy zwracamy false)
*/

	function spamblog_dodaj_url($url) {
	
		$urls = get_option('spamblog_urls');
		
		if (!is_array($urls)) {
			$urls = array();
			add_option('spamblog_urls', $urls);
		}
		
		if (!in_array($url, $urls)) { 
			
			//URLa nie ma w bazie, wiec go dodajemy
			$urls[] = $url;
			update_option('spamblog_urls', $urls);
			return true;
		
		} else {
			
			//URL jest w bazie
			return false;
		
		}
	
	}

?>